<template>
  <form class="change-email" @submit.prevent="onChangeEmail">
    <div>
      <div class="field">
        <input
          type="text"
          placeholder="Nuevo Correo Electronico"
          class="form-control input-sm"
          v-model="formData.email"
          :class="{ error: formError.email }"
        />
      </div>
      <div class="field">
        <input
          type="password"
          placeholder="Contraseña Actual"
          class="form-control input-sm"
          v-model="formData.password"
          :class="{ error: formError.password }"
        />
      </div>
    </div>
    <p v-if="messageError">{{ messageError }}</p>
    <button type="submit" class="btn btn-primary">Actualizar</button>
  </form>
</template>

<script>
import { ref } from "vue";
import * as Yup from "yup";
import { reauthenticate } from "../../utils/firebaseFunctions";
import { Auth } from "../../utils/firebase";

export default {
  title: "ChangeEmail",

  setup() {
    let formData = {};
    let formError = ref({});
    let messageError = ref("");

    const schemaForm = Yup.object().shape({
      email: Yup.string().email(true).required(true),
      password: Yup.string().required(true),
    });

    const onChangeEmail = async () => {
      formError.value = {};
      messageError.value = "";

      try {
        await schemaForm.validate(formData, { abortEarly: false });
        try {
          const { email, password } = formData;
          await reauthenticate(password);
          await Auth.currentUser.updateEmail(email);
          Auth.signOut();
        } catch (error) {
          console.log(error);
          messageError.value = error.message;
        }
      } catch (err) {
        err.inner.forEach((error) => {
          formError.value[error.path] = error.message;
        });
      }
    };

    return {
      formData,
      formError,
      messageError,
      schemaForm,
      onChangeEmail,
    };
  },
};
</script>

<style lang="scss" scoped>
.change-email {
  text-align: center;
}
input.error {
  border-color: #faa;
  background-color: #ffeded;
}

button {
  margin: 20px 0 0 0;
}

button:hover {
  background-color: #3ab025;
}

.field {
  margin-top: 15px;
  margin-bottom: 5px;
}
</style>
